#ifndef MAPSEXCEPTION_HH_
#define MAPSEXCEPTION_HH_
#include <string>
#include <exception>

/** MapsException.hh
 * 
 * Jamie Ballin, Imperial College London
 * 		February 2008
 * 
 * General exception for something's gone gaga!
 * 
 * The author chooses to throw exceptions when a method is asked to do something
 * that should never be asked of it, or it cannot adhere to its "advertised contract".
 * 
 * I wish I could be writing Java. Woe is me.
 */
class MapsException : public std::exception
{
public:
	MapsException(const std::string& aErrorDescription="");
	virtual ~MapsException() throw() {};
	const char* what() const throw();
protected:
	std::string myDescription;
};

#endif /*MAPSEXCEPTION_HH_*/
