#include "MapsTrackManager.hh"
#include "MapsTrack.hh"
#include "MapsSensor.hh"
#include "MapsException.hh"
#include <cmath>
#include <vector>
#include "TRandom2.h"
#include "TFile.h"
#include "TH1F.h"
int main(int argc, const char **argv) {

	for(int d(0); d < argc; d++) {
		std::cout << argv[d] << "\n";
	}
	if(argc != 3) {
		std::cout << "Usage: Rewriter <input file> <outputfile>\n";
		return 0;
	}
	
	MapsTrackManager mtm2;
	std::cout << "Recreating from root file...\n";
	char input[100];
	strcpy(input, argv[1]);
	
	mtm2.recreateFromRootFile(input);
	std::cout << "Rewriting to new root file...\n";
	std::vector<MapsSensor*> s(mtm2.getSensors());
	for(std::vector<MapsSensor*>::iterator it = s.begin(); it != s.end(); ++it) {
		MapsSensor* sensor = *it;
		if(sensor->id() == 2 || sensor->id() == 8) 
			sensor->setPhi(3.14159265358979323846);
		
	}
	
	
	
	std::vector<MapsTrack*> tracks(mtm2.getTracks());
	for(std::vector<MapsTrack*>::iterator it = tracks.begin(); it != tracks.end(); ++it)
		(*it)->eraseGlobalHits();
	
	char output[100];
	strcpy(output, argv[2]);
	mtm2.exportToRootFile(output);
	

	std::cout << "Done.\n";
	return 0;
}


